<template>
  <div>
    <b-modal
      :visible="value"
      @change="$emit('input', $event.target.value)"
      :title="title"
      @hidden="hideModal"
      :hide-footer="hideFooter"
    >
      <div>
        {{ headerText }}
      </div>
      <slot></slot>
      <slot v-if="hideFooter" name="footer"></slot>
      <template #modal-footer>
        <div>
          <b-button
            variant="secondary"
            @click="value = false"
            style="margin-left: -24.5rem"
          >
            {{ $t("cancel") }}
          </b-button>
          <b-button
            variant="danger"
            @click="$emit('confirmModal')"
            style="float: right"
          >
            {{ $t("delete") }}
          </b-button>
        </div>
      </template>
    </b-modal>
  </div>
</template>

<script lang="ts">
import { BButton, BModal } from "bootstrap-vue";
import Vue from "vue";
Vue.component("b-button", BButton);
Vue.component("b-modal", BModal);

export default Vue.extend({
  name: "CoscineModal",
  props: {
    hideFooter: {
      default: false,
      type: Boolean,
    },
    value: {
      default: false,
      type: Boolean,
    },
    title: {
      default: null,
      type: String,
    },
    headerText: {
      default: null,
      type: String,
    },
  },
  methods: {
    hideModal() {
      this.$emit("input", false);
    },
  },
});
</script>

<style>
.modal-dialog {
  top: 4rem;
}
.modal-header .modal-title {
  margin-block-start: 0;
  margin-block-end: 0;
  margin-left: 0;
}
.modal-header button.close {
  text-align: end;
  min-width: 1rem;
}
.modal-body {
  padding: 1rem;
  padding-top: 0;
}
.modal-body .btn {
  margin: 0;
}
</style>
